package org.jbosson.plugins.jbossesb;
import java.util.Set;

import org.mc4j.ems.connection.bean.EmsBean;
import org.mc4j.ems.connection.bean.attribute.EmsAttribute;
import org.rhq.core.pluginapi.inventory.DiscoveredResourceDetails;
import org.rhq.core.pluginapi.inventory.ResourceDiscoveryContext;
import org.rhq.plugins.jmx.JMXComponent;
import org.rhq.plugins.jmx.MBeanResourceDiscoveryComponent;

/**
 * This DiscoveryComponent extends the MBeanResouceDiscoveryComponent, but also
 * adds in the version number from the application server. 
 *
 * @author Tom Cunningham
 */
public class ESBDiscoveryComponent extends MBeanResourceDiscoveryComponent<JMXComponent> {
    @Override
		public Set<DiscoveredResourceDetails> discoverResources(ResourceDiscoveryContext<JMXComponent> context) {
        Set<DiscoveredResourceDetails> jmxResources = super.discoverResources(context);

        String versionNumber;
        try {
			EmsBean bean = context.getParentResourceComponent().getEmsConnection().getBean(SOADiscoveryComponent.SYSTEM_BEAN);
		    EmsAttribute versionAttribute = bean.getAttribute(SOADiscoveryComponent.VERSION_NUMBER);		
		    versionNumber = (String) versionAttribute.refresh();
        } catch (Exception e) {
        	versionNumber = "";
        }
 
        for (DiscoveredResourceDetails jmxResource : jmxResources) {
        	jmxResource.setResourceVersion(versionNumber);
        }

        return jmxResources;
    }
}